<?php
/*
 * Scaffoldr - a PHP scaffold (skeletal) generator for MySQL-Databases.
 * Just provide the connection credentials and this script will generate the CRUD pages for you in
 * a second.
 * URL: http://developer.gauner.org/scaffoldr/
 * Author: Dominik Schulz <lkml_AT_ds_DOT_gauner_DOT_org>
 * License: GPLv2
 */

require_once("../lib/_class.dba.inc.php");

// BEGIN OF FUNCTION DEFINITION

/**
 * write_file
 * @arg $filename (string) - The Filename to write to
 * @arg $string (string) - The String to write in the file
 * @retruns true or false, wheter the operation was successfull or not
 */
function write_file($filename, $string) {
  if(!is_file($filename) || is_writeable($filename)) {
    if(!$handle = @fopen($filename, "w")) {
      //echo("Can't open ".$filename."<br> ");
      return false;
    }
    if(!fwrite($handle,$string)) {
      //echo("Can't write to ".$filename."<br> ");
      return false;
    }
    @fclose($handle);
  } else {
    //echo("File already exists and is not writeable");
    return false;
  }
  @chmod($filename, 0775); // Schreibrecht für die Gruppe auf die Dateien setzen
  @chmod(dirname($filename), 0775);  // Schreibrecht für die Gruppe auf die Verzeichnisse setzen
  return true;
}

function get_html_input($a_type, $a_name) {
        $type = strtolower(strtok($a_type, "("));
        $tmpstr = strtok("(");
        $size = substr($tmpstr, 0, strlen($tmpstr)-1);
	switch($type) {
		case float:
		case double:
		case decimal:
		case tinyint:
		case bigint:
		case smallint:
		case mediumint:
		case int:
		case varchar:
			$retval = '<input type="text" size="50" maxlength="'.$size.'" value="<?= $row['.$a_name.'] ?>" name="'.$a_name.'">'."\n";
			break;
		case datetime:
			$retval = '<h1>TBD</h1>'."\n";
			break;
		case timestamp:
			$retval = '<h1>TBD</h1>'."\n";
			break;
		case time:
			$retval = '<h1>TBD</h1>'."\n";
			break;
		case year:
			$retval = '<h1>TBD</h1>'."\n";
			break;
		case char:
			$retval = '<input type="text" size="1" value="<?= $row['.$a_name.'] ?>" name="'.$a_name.'">'."\n";
			break;
		case tinytext:
		case longtext:
		case mediumtext:
		case text:
			$retval = '<textarea name="'.$a_name.'" cols="80" rows="24"><?= $row['.$a_name.'] ?></textarea>'."\n";
			break;
		case bool:
			$retval = '<select name="'.$a_name.'">'."\n".'<option value="true" <?php if($row['.$a_name.']=="true") echo("selected"); ?>>True</option>'."\n";
			$retval .= '<option value="false" <?php if($row['.$a_name.']=="false") echo("selected"); ?>>False</option>'."\n</select>\n";
			break;
		case enum:
		case set:
			$options = explode(",", $size);
			$retval = '<select name="'.$a_name.'">'."\n";
			for($i=0;$i<count($options);$i++) {
				$options[$i] = substr($options[$i], 1, strlen($options[$i])-2); // remove '
				$retval .= "<option <?php if(\$row[".$a_name."]=='".$options[$i]."') echo(\"selected\"); ?>>".$options[$i]."</option>\n";
			}
			$retval .= '</select>'."\n";
			break;
	}
	return $retval;

}

function format_field_name($field_name) {
	$retval = str_replace("_", " ", $field_name);
	return $retval;
}
// END OF FUNCTION DEFINITION

// Set default values
$php_head_extra = "";
$lib_path = "../";
$config_path = "../";
$http_proto = "http";
$application_title = "Scaffoldr";
$css_path = "../../style.css";
$html_header_extra = "";
$body_header_extra = "";
$body_footer_extra  = "";
$php_order_limit = "25";
$db_user = "";
$db_pass = "";
$db_db = "";
$db_host = "localhost";
$e = "";
$output_dir_index = "<html><head><title>Scaffoldr Directory Index</title><body><p>";

// Check input values
if(IsSet($_REQUEST['db_user']) && IsSet($_REQUEST['db_pass']) && IsSet($_REQUEST['db_db']) && IsSet($_REQUEST['db_host'])
	&& IsSet($_REQUEST['php_head_extra']) && IsSet($_REQUEST['lib_path']) && IsSet($_REQUEST['config_path'])
	&& IsSet($_REQUEST['http_protocol']) && IsSet($_REQUEST['application_title'])
	&& IsSet($_REQUEST['css_path']) && IsSet($_REQUEST['html_header_extra'])
	&& IsSet($_REQUEST['body_header_extra']) && IsSet($_REQUEST['body_footer_extra'])
	&& IsSet($_REQUEST['php_order_limit'])) {
		
	$db_user = $_REQUEST['db_user'];
	$db_pass = $_REQUEST['db_pass'];
	$db_db = $_REQUEST['db_db'];
	$db_host = $_REQUEST['db_host'];
	// setup db connection
	$dba = new dba;
	$dba->appname = "Scaffoldr";
	$dba->database = $db_db;
	$dba->server = $db_host;
	$dba->user = $db_user;
	$dba->password = $db_pass;
	$dba->connect();
		
	$output_dir = "output/";
	$e .= "Running on Database ".$_REQUEST['db_db']." ...\n";
	$output_dir_index .= "<h2>For Database ".$_REQUEST['db_db']." on host ".$_REQUEST['db_host']."</h2><ul>";
	// common settings
	$php_head_extra = $_REQUEST['php_head_extra'];
	//echo("PHP_HEAD_EXTRA:\n".$php_head_extra."\n");
	$lib_path = $_REQUEST['lib_path'];
	//echo("LIB_PATH: ".$lib_path."\n");
	$config_path = $_REQUEST['config_path'];
	//echo("CONFIG_PATH: ".$config_path."\n");
	$http_proto = $_REQUEST['http_protocol'];
	//echo("HTTP_PROTOCOL: ".$http_proto."\n");
	$application_title = $_REQUEST['application_title'];
	//echo("APPLICATION_TITLE: ".$application_title."\n");
	$css_path = $_REQUEST['css_path'];
	//echo("CSS_PATH: ".$css_path."\n");
	$html_header_extra = $_REQUEST['html_header_extra'];
	//echo("HTML_HEADER_EXTRA:\n".$html_header_extra."\n");
	$body_header_extra = $_REQUEST['body_header_extra'];
	//echo("BODY_HEADER_EXTRA:\n".$body_header_extra."\n");
	$body_footer_extra = $_REQUEST['body_footer_extra'];
	//echo("BODY_FOOTER_EXTRA:\n".$body_footer_extra."\n");
	$php_order_limit = $_REQUEST['php_order_limit'];
	//echo("PHP_ORDER_LIMIT: ".$php_order_limit."\n");
	
	// get tables to process
	$query = "SHOW TABLES";
	$results = $dba->query($query);
	// process each table
	while($row = $dba->fetch_array($results)) {
	$scaffold_name = $row[0];
	$e .= "-> Processing: ".$scaffold_name." ... ";
	$output_dir_index .= "<li><a href=\"".$scaffold_name."\">".$scaffold_name."</a></li>";
	// create dir for scaffolding
	if(!is_dir($output_dir.$scaffold_name)) {
	  @mkdir($output_dir.$scaffold_name);
	} else {
	  //echo("Dir already created.\n ");
	}
	if(is_dir($output_dir.$scaffold_name)) {
		//echo("--> Created subdir: ".$scaffold_name."\n");
	} else {
		//echo("--> Error creating subdir: ".$scaffold_name."\n");
	}
	
	// ### create delete.php
	$template = "";
	$output = "";
	$template = file_get_contents("templates/delete.tpl");
	$output = str_replace("PHP_HEAD_EXTRA",$php_head_extra,$template);
	$output = str_replace("LIB_PATH",$lib_path,$output);
	$output = str_replace("CONFIG_PATH",$config_path,$output);
	$output = str_replace("HTTP_PROCOL",$http_proto,$output);
	$output = str_replace("APPLICATION_TITLE",$application_title,$output);
	$output = str_replace("CSS_PATH",$css_path,$output);
	$output = str_replace("HTML_HEADER_EXTRA",$html_header_extra,$output);
	$output = str_replace("BODY_HEADER_EXTRA",$body_header_extra,$output);
	$output = str_replace("BODY_FOOTER_EXTRA",$body_footer_extra,$output);
	$output = str_replace("PHP_ORDER_LIMIT",$php_order_limit,$output);
	write_file($output_dir.$scaffold_name."/delete.php", $output);
	//echo("--> Created file: ".$scaffold_name."/delete.php.\n");
	
	
	// ### create edit.php
	$template = "";
	$output = "";
	$template = file_get_contents("templates/edit.tpl");
	$output = str_replace("PHP_HEAD_EXTRA",$php_head_extra,$template);
	$output = str_replace("LIB_PATH",$lib_path,$output);
	$output = str_replace("CONFIG_PATH",$config_path,$output);
	$output = str_replace("HTTP_PROCOL",$http_proto,$output);
	$output = str_replace("APPLICATION_TITLE",$application_title,$output);
	$output = str_replace("CSS_PATH",$css_path,$output);
	$output = str_replace("HTML_HEADER_EXTRA",$html_header_extra,$output);
	$output = str_replace("BODY_HEADER_EXTRA",$body_header_extra,$output);
	$output = str_replace("BODY_FOOTER_EXTRA",$body_footer_extra,$output);
	$output = str_replace("PHP_ORDER_LIMIT",$php_order_limit,$output);
	$output = str_replace("SQL_QUERY","SELECT * FROM ".$scaffold_name." WHERE id='\$_GET[id]' LIMIT 1",$output);
	// get table description
	$query = "DESCRIBE ".$scaffold_name;
	//echo("Querying for table description: ".$query."\n");
	$inner_results = $dba->query($query);
	
	// create the content of BODY_FORM_MAIN
	$d_edit = "<input type=\"hidden\" value=\"<?= \$row[id] ?>\" name=\"id\">\n";
	$dba->fetch_array($inner_results); // we don't want the id field to show up
	while($inner_row = $dba->fetch_array($inner_results)) {
		if(($inner_row[0] == "created_at") || ($inner_row[0] == "updated_at")) {
			// omit, those fields are updated by the scaffold
		} else {
			$d_edit .= "\t<tr>\n";
			$d_edit .= "\t<td>".format_field_name($inner_row[0])."</td>\n";
			$d_edit .= "\t<td>".get_html_input($inner_row[1],$inner_row[0])."</td>\n";
			$d_edit .= "\t</tr>\n";
		}
	}
	$output = str_replace("BODY_FORM_MAIN",$d_edit,$output);
	
	write_file($output_dir.$scaffold_name."/edit.php", $output);
	unset($d_edit);
	//echo("--> Created file: ".$scaffold_name."/edit.php.\n");
	
	
	// ### create index.php (redirecting to default action = list)
	$template = "";
	$output = "";
	$template = file_get_contents("templates/index.tpl");
	$output = str_replace("PHP_HEAD_EXTRA",$php_head_extra,$template);
	$output = str_replace("LIB_PATH",$lib_path,$output);
	$output = str_replace("CONFIG_PATH",$config_path,$output);
	$output = str_replace("HTTP_PROCOL",$http_proto,$output);
	$output = str_replace("APPLICATION_TITLE",$application_title,$output);
	$output = str_replace("CSS_PATH",$css_path,$output);
	$output = str_replace("HTML_HEADER_EXTRA",$html_header_extra,$output);
	$output = str_replace("BODY_HEADER_EXTRA",$body_header_extra,$output);
	$output = str_replace("BODY_FOOTER_EXTRA",$body_footer_extra,$output);
	$output = str_replace("PHP_ORDER_LIMIT",$php_order_limit,$output);
	write_file($output_dir.$scaffold_name."/index.php", $output);
	//echo("--> Created file: ".$scaffold_name."/index.php.\n");
	
	
	// ### create insert.php
	$template = "";
	$output = "";
	$template = file_get_contents("templates/insert.tpl");
	$output = str_replace("PHP_HEAD_EXTRA",$php_head_extra,$template);
	$output = str_replace("LIB_PATH",$lib_path,$output);
	$output = str_replace("CONFIG_PATH",$config_path,$output);
	$output = str_replace("HTTP_PROCOL",$http_proto,$output);
	$output = str_replace("APPLICATION_TITLE",$application_title,$output);
	$output = str_replace("CSS_PATH",$css_path,$output);
	$output = str_replace("HTML_HEADER_EXTRA",$html_header_extra,$output);
	$output = str_replace("BODY_HEADER_EXTRA",$body_header_extra,$output);
	$output = str_replace("BODY_FOOTER_EXTRA",$body_footer_extra,$output);
	$output = str_replace("PHP_ORDER_LIMIT",$php_order_limit,$output);
	// get table description
	$query = "DESCRIBE ".$scaffold_name;
	//echo("Querying for table description: ".$query."\n ");
	$inner_results = $dba->query($query);
	$sqlquery = 'INSERT INTO '.$scaffold_name.' (';
	$dba->fetch_array($inner_results); // we don't want the id field to show up
	while($inner_row = $dba->fetch_array($inner_results)) {
		$sqlquery .= $inner_row[0].",";
	}
	$sqlquery = substr($sqlquery,0,strlen($sqlquery)-1); // remove the last ','
	$sqlquery .= ") VALUES (";
	$inner_results = $dba->query($query);
	$dba->fetch_array($inner_results); // we don't want the id field to show up
	while($inner_row = $dba->fetch_array($inner_results)) {
		if(($inner_row[0] == "created_at") || ($inner_row[0] == "updated_at")) {
			$sqlquery .= "'\".time().\"',";
		} else {
			$sqlquery .= "'\".\$_POST[".$inner_row[0]."].\"',";
		}
	}
	$sqlquery = substr($sqlquery,0,strlen($sqlquery)-1); // remove the last ','
	$sqlquery .= ')';
	$output = str_replace("SQL_QUERY",$sqlquery,$output);
	write_file($output_dir.$scaffold_name."/insert.php", $output);
	unset($d_insert);
	//echo("--> Created file: ".$scaffold_name."/insert.php.\n");
	
	
	// ### create list.php
	$template = "";
	$output = "";
	$template = file_get_contents("templates/list.tpl");
	$output = str_replace("PHP_HEAD_EXTRA",$php_head_extra,$template);
	$output = str_replace("LIB_PATH",$lib_path,$output);
	$output = str_replace("CONFIG_PATH",$config_path,$output);
	$output = str_replace("HTTP_PROCOL",$http_proto,$output);
	$output = str_replace("APPLICATION_TITLE",$application_title,$output);
	$output = str_replace("CSS_PATH",$css_path,$output);
	$output = str_replace("HTML_HEADER_EXTRA",$html_header_extra,$output);
	$output = str_replace("BODY_HEADER_EXTRA",$body_header_extra,$output);
	$output = str_replace("BODY_FOOTER_EXTRA",$body_footer_extra,$output);
	
	$my_list_limit = '$list_limit = '.$php_order_limit.";\n";
	$my_list_limit .= 'switch($_GET[\'order\']) {'."\n";
	
	$inner_results = $dba->query($query);
	$d_list .= "<tr>\n";
	$dba->fetch_array($inner_results); // we don't want the id field to show up
	while($inner_row = $dba->fetch_array($inner_results)) {
		$d_list .= "<th><a href=\"list.php?order=".$inner_row[0]."\">".format_field_name($inner_row[0])."</a></th>";
	}
	$d_list .= "<th>CRUD</th></tr>\n";
	$d_list .= '<?php '."\n";
	$d_list .= 'while($row = $dba->fetch_array($results)) {'."\n".'echo("<tr>\n");'."\n";
	$inner_results = $dba->query($query);
	$dba->fetch_array($inner_results); // we don't want the id field to show up
	$is_first = true;
	while($inner_row = $dba->fetch_array($inner_results)) {
		$a1 = "";
		$a2 = "";
		if($is_first) {
			$a1 = "<a href='edit.php?id=".'$row[id]'."'>";
			$a2 = "</a>";
			$is_first = false;
		}
		if(($inner_row[0] == "created_at") || ($inner_row[0] == "updated_at")) {
			$d_list .= 'echo("\t<td>'.$a1.'".date("d.m.y h:i:s", $row['.$inner_row[0].'])."'.$a2.'</td>\n");'."\n";
		} elseif($inner_row[1] == "text") {
			$d_list .= 'echo("\t<td>'.$a1.'".substr(htmlentities($row['.$inner_row[0].']),0,80)." ...'.$a2.'</td>\n");'."\n";
		} else {
			$d_list .= 'echo("\t<td>'.$a1.'".$row['.$inner_row[0].']."'.$a2.'</td>\n");'."\n";
		}
		$my_list_limit .= "\tcase ".$inner_row[0].":\n\t\t\$order_clause = \" ORDER BY ".$inner_row[0]."\";\n";
		$my_list_limit .= "\t\t\$order_link_arg = \"".$inner_row[0]."\";\n\t\tbreak;\n";
	}
	$d_list .= 'echo("<td><a href=\"show.php?id=".$row[id]."\">Show</a>'."\n".'<a href=\"edit.php?id=".$row[id]."\">Edit</a>'."\n".'<a href=\"delete.php?id=".$row[id]."\">Delete</a></td>");'."\n";
	$d_list .= 'echo("</tr> ");'."\n".'}'."\n".'?>'."\n".'</table>'."\n".'<br />'."\n";

	$my_list_limit .= "\tdefault:\n\t\t\$order_clause = \" ORDER BY id\";\n}\n";
	
	$output = str_replace("HTML_TABLE_TEXT",$d_list,$output);
	$output = str_replace("SQL_TABLE_NAME",$scaffold_name,$output);
	$output = str_replace("PHP_ORDER_LIMIT",$my_list_limit,$output);
	write_file($output_dir.$scaffold_name."/list.php", $output);
	unset($d_list);
	//echo("--> Created file: ".$scaffold_name."/list.php.\n");
	
	
	// ### create new.php
	$template = "";
	$output = "";
	$template = file_get_contents("templates/new.tpl");
	$output = str_replace("PHP_HEAD_EXTRA",$php_head_extra,$template);
	$output = str_replace("LIB_PATH",$lib_path,$output);
	$output = str_replace("CONFIG_PATH",$config_path,$output);
	$output = str_replace("HTTP_PROCOL",$http_proto,$output);
	$output = str_replace("APPLICATION_TITLE",$application_title,$output);
	$output = str_replace("CSS_PATH",$css_path,$output);
	$output = str_replace("HTML_HEADER_EXTRA",$html_header_extra,$output);
	$output = str_replace("BODY_HEADER_EXTRA",$body_header_extra,$output);
	$output = str_replace("BODY_FOOTER_EXTRA",$body_footer_extra,$output);
	$output = str_replace("PHP_ORDER_LIMIT",$php_order_limit,$output);
	$inner_results = $dba->query($query);
	$dba->fetch_array($inner_results); // we don't want the id field to show up
	while($inner_row = $dba->fetch_array($inner_results)) {
		if(($inner_row[0] == "created_at") || ($inner_row[0] == "updated_at")) {
			// omit, those fields are updated by the scaffold
		} else {
			$d_new .= "<h3>".format_field_name($inner_row[0])."</h3>\n";
			$d_new .= get_html_input($inner_row[1],$inner_row[0])."\n";
		}
	}
	$output = str_replace("BODY_FORM_MAIN",$d_new,$output);
	write_file($output_dir.$scaffold_name."/new.php", $output);
	unset($d_new);
	//echo("--> Created file: ".$scaffold_name."/new.php.\n");
	
	
	// ### create remove.php
	$template = "";
	$output = "";
	$template = file_get_contents("templates/remove.tpl");
	$output = str_replace("PHP_HEAD_EXTRA",$php_head_extra,$template);
	$output = str_replace("LIB_PATH",$lib_path,$output);
	$output = str_replace("CONFIG_PATH",$config_path,$output);
	$output = str_replace("HTTP_PROCOL",$http_proto,$output);
	$output = str_replace("APPLICATION_TITLE",$application_title,$output);
	$output = str_replace("CSS_PATH",$css_path,$output);
	$output = str_replace("HTML_HEADER_EXTRA",$html_header_extra,$output);
	$output = str_replace("BODY_HEADER_EXTRA",$body_header_extra,$output);
	$output = str_replace("BODY_FOOTER_EXTRA",$body_footer_extra,$output);
	$output = str_replace("PHP_ORDER_LIMIT",$php_order_limit,$output);
	$d_remove .= 'DELETE FROM '.$scaffold_name.' WHERE id=\'".$id."\' LIMIT 1';
	$output = str_replace("SQL_QUERY",$d_remove,$output);
	write_file($output_dir.$scaffold_name."/remove.php", $output);
	unset($d_remove);
	//echo("--> Created file: ".$scaffold_name."/remove.php.\n");
	
	
	// ### create show.php
	$template = "";
	$output = "";
	$template = file_get_contents("templates/show.tpl");
	$output = str_replace("PHP_HEAD_EXTRA",$php_head_extra,$template);
	$output = str_replace("LIB_PATH",$lib_path,$output);
	$output = str_replace("CONFIG_PATH",$config_path,$output);
	$output = str_replace("HTTP_PROCOL",$http_proto,$output);
	$output = str_replace("APPLICATION_TITLE",$application_title,$output);
	$output = str_replace("CSS_PATH",$css_path,$output);
	$output = str_replace("HTML_HEADER_EXTRA",$html_header_extra,$output);
	$output = str_replace("BODY_HEADER_EXTRA",$body_header_extra,$output);
	$output = str_replace("BODY_FOOTER_EXTRA",$body_footer_extra,$output);
	$output = str_replace("PHP_ORDER_LIMIT",$php_order_limit,$output);
	$sqlquery = 'SELECT * FROM '.$scaffold_name.' WHERE id=\'".$_GET[id]."\' LIMIT 1';
	$output = str_replace("SQL_QUERY",$sqlquery,$output);
	$d_show = "<table border=\"1\">\n";
	$inner_results = $dba->query($query);
	while($inner_row = $dba->fetch_array($inner_results)) {
		$d_show .= "<tr>\n";
		$d_show .= "<td>".format_field_name($inner_row[0])."</td>\n";
		$d_show .= '<td><?= $row['.$inner_row[0].'] ?>'."</td>\n";
		$d_show .= "</tr>\n";
	}
	$d_show .= "</table>\n";
	$output = str_replace("BODY_TEXT_MAIN",$d_show,$output);
	write_file($output_dir.$scaffold_name."/show.php", $output);
	unset($d_show);
	unset($sqlquery);
	//echo("--> Created file: ".$scaffold_name."/show.php.\n");
	
	
	// ### create update.php
	$template = "";
	$output = "";
	$template = file_get_contents("templates/update.tpl");
	$output = str_replace("PHP_HEAD_EXTRA",$php_head_extra,$template);
	$output = str_replace("LIB_PATH",$lib_path,$output);
	$output = str_replace("CONFIG_PATH",$config_path,$output);
	$output = str_replace("HTTP_PROCOL",$http_proto,$output);
	$output = str_replace("APPLICATION_TITLE",$application_title,$output);
	$output = str_replace("CSS_PATH",$css_path,$output);
	$output = str_replace("HTML_HEADER_EXTRA",$html_header_extra,$output);
	$output = str_replace("BODY_HEADER_EXTRA",$body_header_extra,$output);
	$output = str_replace("BODY_FOOTER_EXTRA",$body_footer_extra,$output);
	$output = str_replace("PHP_ORDER_LIMIT",$php_order_limit,$output);
	$d_update = 'UPDATE '.$scaffold_name.' SET ';
	$inner_results = $dba->query($query);
	$dba->fetch_array($inner_results); // we don't want the id field to show up
	while($inner_row = $dba->fetch_array($inner_results)) {
		if($inner_row[0] == "created_at") {
			// omit this filed on update
		} elseif($inner_row[0] == "updated_at") {
			$d_update .= $inner_row[0]."='\".time().\"',";
		} else {
			$d_update .= $inner_row[0]."='\$_POST[".$inner_row[0]."]',";
		}
	}
	$d_update = substr($d_update,0,strlen($d_update)-1); // remove last ','
	$d_update .= ' WHERE id=\'$_POST[id]\'';
	$output = str_replace("SQL_QUERY",$d_update,$output);
	write_file($output_dir.$scaffold_name."/update.php", $output);
	unset($d_update);
	//echo("--> Created file: ".$scaffold_name."/update.php.\n");
	
	// done with this table
	$e .= " done.\n";
}
$output_dir_index .= "</ul></body></html>";
// create a directory index in case the dirindex option is disabled in the webserver config.
write_file($output_dir."/index.html",$output_dir_index);
// copy the dba class
$dbclass = file_get_contents("templates/_class.dba.inc.tpl");
write_file($output_dir."/_class.dba.inc.php",$dbclass);
// copy the session file
$sessionfile = file_get_contents("templates/_static.session.inc.tpl");
write_file($output_dir."/_static.session.inc.php",$sessionfile);
// copy the dba config
$dbconfig = file_get_contents("templates/_conf.dba.inc.tpl");
$output = str_replace("CONF_APPNAME",$application_title,$dbconfig);
$output = str_replace("CONF_DB",$db_db,$output);
$output = str_replace("CONF_HOST",$db_host,$output);
$output = str_replace("CONF_USER",$db_user,$output);
$output = str_replace("CONF_PASS",$db_pass,$output);
write_file($output_dir."/_conf.dba.inc.php",$output);
$e .= "DONE\n";
} else {
	$e .= "Missing Parameters. Not executing. Please re-check your input.";
}
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<link rel="stylesheet" type="text/css" media="screen" href="style.css" />
<title>Scaffoldr</title>
</head>
<body>
<p>
<a href="http://developer.gauner.org/scaffoldr/"><img src="logo.png" alt="Scaffoldr - PHP Scaffold Generator 2.0" border="0"></a>
</p>
<table border="0">
<tr>
<td>
<h2>Database Settings</h2>
<form action="index.php" method="POST">
<table border="0">
<tr>
<td>
<b>User</b>:</td><td><input type="text" name="db_user" value="<?= $db_user ?>">
</td>
</tr>
<tr>
<td>
<b>Password</b>:</td><td><input type="password" name="db_pass" value="">
</td>
</tr>
<tr>
<td>
<b>Database</b>:</td><td><input type="text" name="db_db" value="<?= $db_db ?>">
</td>
</tr>
<tr>
<td>
<b>Host</b>:</td><td><input type="text" name="db_host" value="<?= $db_host ?>">
</td>
</tr>
</table>
<input type="submit" name="submit" value="--> Run! <--">
<p>
<h2>Options</h2>
<table border="0">
<tr>
<td>
<b>lib_path</b>:</td><td><input type="text" name="lib_path" value="<?= $lib_path ?>">
</td>
</tr>
<tr>
<td>
<b>config_path</b>:</td><td><input type="text" name="config_path" value="<?= $config_path ?>">
</td>
</tr>
<tr>
<td>
<b>http_protocol</b>:</td><td><input type="text" name="http_protocol" value="<?= $http_proto ?>">
</td>
</tr>
<tr>
<td>
<b>application_title</b>:</td><td><input type="text" name="application_title" value="<?= $application_title ?>">
</td>
</tr>
<tr>
<td>
<b>css_path</b>:</td><td><input type="text" name="css_path" value="<?= $css_path ?>">
</td>
</tr>
<tr>
<td>
<b>php_order_limit</b>:</td><td><input type="text" name="php_order_limit" value="<?= $php_order_limit ?>">
</td>
</tr>
</table>
<b>html_header_extra</b>: <br>
<textarea rows="5" cols="80" name="html_header_extra"><?= $html_header_extra ?></textarea><br>
<b>body_header_extra</b>: <br>
<textarea rows="5" cols="80" name="body_header_extra"><?= $body_header_extra ?></textarea><br>
<b>body_footer_extra</b>: <br>
<textarea rows="5" cols="80" name="body_footer_extra"><?= $body_footer_extra  ?></textarea><br>
<b>php_head_extra</b>:<br>
<textarea rows="5" cols="80" name="php_head_extra"><?= $php_head_extra ?></textarea><br>

</form>
</p>
</td>
<td width="50%" valign="top">
<p>
<h4>Database Settings</h4>
Enter your MySQL-Database settings here. The Scaffoldr will try connect using this credentials and, if successful, create
a scaffold for the entire database. The resulting html files will be put in the subfolder <i><a href="output/">output</a></i>.<br>
Scaffoldr makes some assumptions about the database layout. It expects the primary key to be called id. If you layout if different
it will still generate the scaffold, but you'll need to change the parameters from id to something else.<br>
<h4>Options</h4>
These are optional options to tweak the output of the Scaffoldr.
<ul>
<li><b>lib_path</b>: Specify where the <i>_class.dba.inc.php</i> is located relative to the generated files. Note that for every
table in your database there will be a seperate directory under output so you probably need at least a ../ here.</li>
<li><b>config_path</b>: Specify where the <i>_conf.dba.inc.php</i> is located relative to the generated files. The note for lib_path also applies here.</li>
<li><b>http_protocol</b>: Specify which http protocol to use. Probably either http or https. Could also be function call to
determine this on the fly.</li>
<li><b>application_title</b>: This is put as the first part of the html title tag.</li>
<li><b>css_path</b>: Spefciy where the css file is located.</li>
<li><b>php_order_limit</b>: The default number of rows to display on a single page. Can also be a function call to
determine this on the fly.</li>
<li><b>html_header_extra</b>: This option is placed in the template. See the template for more information.</li>
<li><b>body_header_extra</b>: This option is placed in the template. See the template for more information.</li>
<li><b>body_footer_extra</b>: This option is placed in the template. See the template for more information.</li>
<li><b>php_head_extra</b>: This option is placed in the template. See the template for more information.</li>
</ul>
<h4>Templates</h4>
Have a look at the <i><a href="templates/">templates</a></i> subdir. The templates can be changed in any way as long as the markers in UPPER cases remain intact.
</p>
<p>
<h2>Status</h2>
<textarea rows="25" cols="70">
<?= $e ?>
</textarea>
</p>
</td>
</tr>
</table>
</body>
</html>
